import scrape
import os
import sys
import math

def Progress(aCount, aTotal):
	p = (100 * aCount) / aTotal 
	print("Progress " + str(aCount) + " games (" + str(math.ceil(p)) + "%)   ", end='\r', flush=True)

def PrintPlatformList():
	platforms = scrape.Platforms()
	platforms.Print()
	
def main(argv):
	if (len(argv) == 0):
		PrintPlatformList()
		return

	if (len(argv) == 1):
		platforms = scrape.Platforms()
		platformId = scrape.Utils.GetNum(argv[0])
		if (platformId == 0):
			platform = platforms.GetPlatformByName(argv[0])
		else:
			platform = platforms.GetPlatformById(platformId)
		
		if (platform.id > 0):
			print("Creating output for platform: " + str(platform.id) + ", " + platform.name + ", " + platform.description)
			scrape.CreateOutputFilesForPlatform(platform, Progress)
		else:
			print("Parameter \"" + argv[0] + "\" doesn't refer to a valid platform number or name")
		return
	
	print("Usage: scrape <platform-id | platform-name>")
	print("  without parameters, the list of platforms is returned")
	

if __name__ == "__main__":
   main(sys.argv[1:])
   