import subprocess
import os
import shutil

badRoms = ['[a', '[p', '[b', '[t', '[f', '[T', '[T', '[h', '[o', '(A)', '(B)', '(K)', '(F)', '(S)', '(FC)', '(SW)', '(FN)', '(G)', '(GR)', '(HK)', '(I)', '(H)']

def isBadRom(file):
	for x in badRoms:
		if x in file:
			return True
	return False

def RemoveBadRoms(dir):
	for root, dirs, files in os.walk(dir):
		removeList = [x for x in files if isBadRom(x)]
		success = len(files) - len(removeList) > 0
		if success:
			for x in removeList:
				#print("Removing: " + os.path.join(dir, x))
				os.remove(os.path.join(dir, x))
		return success


for root, dirs, files in os.walk("."):
	for file in files:
		if file.endswith(".7z"):
			game = os.path.splitext(file)[0]
			dir = game + ".dir"
			if not os.path.exists(dir):
				os.makedirs(dir)
			subprocess.call(['7z', 'e', file, '-o'+dir])
			success = RemoveBadRoms(dir)
			subprocess.call(['zip', '-v', '-j', game+'.zip', '-r', dir])
			if success:
				shutil.rmtree(dir)
			#print(os.path.join(root, file))