#!/bin/bash
if [ ! -f "./src/app/app.cpp" ]; then
	echo "You are not in rgl's root directory, bailing out."
	exit
fi

RELEASE_DIR=release
ZIP_VERSION="$(echo APP_VERSION | cpp -P -include src/app/version.h)"
ZIP=${RELEASE_DIR}/rgl-linux-src-${ZIP_VERSION}

##################################
#
# Memory jog
#
##################################
read -p "Have you updated the version number? " answer
if [ "$answer" != "y" ]; then
	echo "Bailing out."
	exit
fi

read -p "Have you updated readme.txt? " answer
if [ "$answer" != "y" ]; then
	echo "Bailing out."
	exit
fi


##################################
#
# Actual release handling
#
##################################
rm -f $ZIP.tgz


# Zip things up
tar --exclude='./release' --exclude='./build' --exclude='./exe' --exclude='./win32' --exclude='./.git' --exclude='./.kdev4' --exclude="./user" --exclude="./rgl" --exclude="./todo" -cvf $ZIP .
tar -rvf $ZIP ./user/config.rc
gzip -S .tgz $ZIP
#zip -r yamm/$ZIP . -x release/\* -x build/\* -x exe/\* -x win32/\* -x .git/\*
#zip -r yamm/$ZIP yamm/src yamm/data yamm/fonts yamm/images yamm/theme yamm/sounds
#zip yamm/$ZIP yamm/yamm.kdev4 yamm/Makefile yamm/linux_system.rc yamm/README.txt yamm/scripts/release.sh
