use strict;
use warnings;

#
# Run this script in a directory with rom files. It will delete all .rom files which are not references in mameinfo.dat
#
my $filename = 'mameinfo.dat';
open(my $fh, $filename)
	or die "Could not open file '$filename' $!";

my %rommap;
while (my $line = <$fh>) 
{
	chomp $line;
	my @words = split(/=/, $line); 
	$rommap{$words[0]} = 1;
}


opendir(DIR, ".") or die $!;
while (my $file = readdir(DIR)) 
{
	next if ($file !~ m/\.zip/);

	my @words1 = split(/\./, $file); 
	my $rom = $words1[0];

	if(!exists($rommap{$rom}))
	{
		print "Deleting: $file\n";
		unlink($file);
	}

}
closedir(DIR);
