/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __GAME_ENGINE_PROPERTIES_H
#define __GAME_ENGINE_PROPERTIES_H

#include "mediadirectory.h"

const int KNumOfUserMediaDirectories = 10;
const int KNumOfBuiltinMediaDirectories = 3;
const int KTotalNumOfMediaDirectories = KNumOfBuiltinMediaDirectories + KNumOfUserMediaDirectories;

const std::string KBuiltinDirectoryNames[KNumOfBuiltinMediaDirectories] = {"snap", "videosnaps", "marquees"};

class TGameEngineProperties
{
public:
	std::string iExeName;
	std::string iCommandLine;
	std::string iRomFileExtension;
	bool 		iIncludeAllRoms;
	TMediaDirectory	iRomDirectory;
	std::string 	iMediaDirectory;
	TMediaDirectory	iMediaDirectories[KTotalNumOfMediaDirectories];
	
	std::string GetDirectoryPath(const std::string& aDirectoryName)
	{
		for (int i=0 ; i< KTotalNumOfMediaDirectories ; i++)
			if (iMediaDirectories[i].iName.compare(aDirectoryName) == 0)
				return iMediaDirectories[i].iPathName;

		return "";
	}
};


#endif // __GAME_ENGINE_PROPERTIES_H
