/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __MEDIA_DIRECTORY_H
#define __MEDIA_DIRECTORY_H

#include <string>

class TMediaDirectory
{
public:
	std::string iPathName;
	std::string iName;
	std::string iIgnoreLeading;
	std::string iIgnoreTrailing;
	
	/*
	 * Some media collections I've downloaded (particularly GBA) look like this:
	 * 		2427 - Megaman Battle Network 6 Cybeast Gregar (U).zip 
	 * In order to get the real name of the game, the prefix "2427 -" should be removed and also the "(U") postfix
	 * That what the leading and trailing char are for. In this case leading is '-' and trailing is '('
	 */
	char GetIgnoreLeadingChar() const { return iIgnoreLeading.size() > 0 ? iIgnoreLeading[0] : 0;}
	char GetIngoreTrailingChar() const { return iIgnoreTrailing.size() > 0 ? iIgnoreTrailing[0] : 0;}
};


#endif // __MEDIA_DIRECTORY_H