/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __RECONSILE_NAME_H
#define __RECONSILE_NAME_H

#include "game.h"
#include "mediadirectory.h"

std::string ConvertName(const std::string& aName, char aIgnoreLeading, char aIgnoreTrailing);
std::string PartialConvertName(const std::string& aName, char aIgnoreLeading, char aIgnoreTrailing);

class MediaDirectoryMapper
{
public:
	MediaDirectoryMapper() { }
	
	void AddDirectory(const TMediaDirectory& aMediaDirectory, const TGameMap& aGameMap, const std::string& aUserDir);
	void AddDirectory(const TMediaDirectory& aMediaDirectory, const std::string& aFileExtension = "");
	std::string GetMediaFileName(const std::string& aDirectory, const std::string& aName) { return iMapper[aDirectory][aName]; }
	bool HasMediaFile(const std::string& aDirectory, const std::string& aName) 
	{
		bool hasMediaFile = iMapper[aDirectory].find(aName) !=  iMapper[aDirectory].end(); 
//		printf("hasMediaFilet(%s) %s --> %s\n", aDirectory.c_str(), aName.c_str(), hasMediaFile ? "true" : "false");
		return hasMediaFile;
	
	}
	const std::map<std::string, std::string>& GetMap(const std::string& aDirectory) { return iMapper[aDirectory]; }
	
private:
	void ReadMediaMapFile(const std::string& aDirectory, const std::string& aMediaMapFileName, const TGameMap& aGameMap);
	void CreateMediaMapFile(const TMediaDirectory& aMediaDirectory, const std::string& aMediaMapFileName, const TGameMap& aGameMap);
	
	static std::string GetMediaMapFileName(const std::string& aDirectory);

	std::map<std::string, std::map<std::string, std::string>> iMapper;
};

#endif