/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#include "gameinfocontroller.h"
#include "gameenginemanager.h"
#include "gameinfodialog.h"
#include "appcommands.h"
#include "themeproperties.h"


void GameInfoController::MenuItemCommand(const sdl::MenuItem& aMenuItem, const sdl::TCommand& aCommand)
{
	if ((aCommand == (int) EGameInfo) && !aMenuItem.GetCommand().empty())
		ShowGameInfo(aMenuItem.GetCommand(), aMenuItem.GetName());
}

void GameInfoController::ShowGameInfo(const std::string& aGameID, const std::string& aGameLongName)
{
	std::string gameInfoText;
	
	iGameEngineManager.GetGameInfo(aGameID, gameInfoText);

	GameInfoDialog gameInfoDialog(gameInfoText);
	gameInfoDialog.SetTitle(std::string("Game info: ") + aGameLongName.c_str());
	gameInfoDialog.Execute();
}


