/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __GAME_INFO_CONTROLLER_H
#define __GAME_INFO_CONTROLLER_H

#include "sdlimenulistener.h"
#include "game.h"
#include "types.h"

class GameInfoModel;
class GameEngineManager;

class GameInfoController : public sdl::IMenuItemListener
{
public:
	GameInfoController(GameEngineManager& aGameEngineManager) : iGameEngineManager(aGameEngineManager) {}
	
private: // from IMenuItemListener
	virtual void MenuItemHighlighted(const sdl::MenuItem& aMenuItem) override { }
	virtual void MenuItemCommand(const sdl::MenuItem& aMenuItem, const sdl::TCommand& aCommand) override;
	virtual void MenuListChanged(sdl::Menu& aMenu) override {}
	
private:
	void ShowGameInfo(const std::string& aGameID, const std::string& aGameLongName);
	void FormatGameInfoText(const std::string& aGameInfoText, std::string& aFormattedGameInfoText);

	void ProcessLine(const std::string& aLine, std::string& aFormattedGameInfoText);
	
	GameEngineManager& iGameEngineManager;
};


#endif // __GAME_INFO_CONTROLLER_H