/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#include "homecontroller.h"
#include "appcommands.h"
#include "sdlinfoprint.h"
#include "gamemenus.h"
#include "sdlmenu2dwidget.h"

void HomeController::MenuItemCommand(const sdl::MenuItem& aMenuItem, const sdl::TCommand& aCommand)
{
	if ((int) aCommand == TAppCommand::EHome)
	{
		const std::vector<std::string>& menuList = iGameMenus.GetCategoriesList();
		if (menuList.size() > 0)
		{
			iMenu2DWidget.SwitchToMenu(menuList.at(0));
		}
		else
		{
			sdl::InfoPrint::Message("Home - no game menus to go to");
		}
	}
}
