/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __USER_PROPERTIES_H
#define __USER_PROPERTIES_H

#include "platform.h"

class UserProperties;
extern UserProperties AppUserProperties;

class UserProperties
{
public:
	class TRecentGames
	{
	public:
		bool iEnabled = true;
		int  iMax = 10;
	};
	TRecentGames iRecentGames;

	class TFavsGames
	{
	public:
		bool iEnabled = true;
		int  iMax = 10;
	};
	TFavsGames iFavsGames;
	
	class TFilterGames
	{
	public:
		int  iMaxPlayers = -1;
		int  iMaxButtons = -1;
		bool iSimultaneousPlayers = true;
	};
	TFilterGames iFilterGames;

	class TGameCategories
	{
	public:
		std::vector<std::string> iExclude;
	};
	TGameCategories iGameCategories;

	class TGameEngines
	{
	public:
		std::vector<std::string> iExclude;
	};
	TGameEngines iGameEngines;
	
	class TVideoSetting
	{
	public:
		bool	iVideoEnabled = true;
		bool	iMuteAudio = false;
		int		iAudioVolumeDuringVideo = 80;
		int		iStartAfterDelay = 500;
		bool 	iTimeLabel = true;
	};
	TVideoSetting iVideoSetting;
	
	std::string iThemeName = "default";

	std::string iLastMenuName;
	std::string iLastMenuItemName;
};

UserProperties DECLARE_ONCE AppUserProperties;

#endif // __USER_PROPERTIES_H