#include "sdlapplication.h"
#include "sdldialog.h"
#include "sdlthemeproperties.h"
#include "sdlcommands.h"

// needed for WIN32
#undef main

const int KCommandPopupDialog = sdl::EUserDefined;

class HelloWordLabel : public sdl::LabelWidget
{
	virtual bool HandleCommand(sdl::TCommand aCommand)
	{
		if (aCommand == KCommandPopupDialog)
		{
			sdl::LabelWidget* label = new sdl::LabelWidget();
			label->SetText("Press escape to dismiss it");

			sdl::Dialog* dialog = new sdl::Dialog();
			dialog->SetSize(400, 200);
			dialog->SetTitle("Hello World!");
			dialog->SetAutoCenter(true);
			dialog->AddWidget(*label, true);
			dialog->Execute();
		}
		return false; 
	}
};

void ConfigureSDLProperties()
{
	sdl::SDLThemeProperties.iDefaultWindowProperties.iRoundedRect.iFrameColor = sdl::TColor::KRed;
	sdl::SDLThemeProperties.iDefaultWindowProperties.iLabelTitle.iFont.iTextColor = sdl::TColor::KBlue;
}


int main(int, char*[])
{
	ConfigureSDLProperties();
	
	sdl::System::FontDirs.AddDirectoryName("fonts");
	sdl::EventManager::AddKeyTranslation(SDLK_d, true, false, KCommandPopupDialog);
		
	sdl::Application application("test");
	application.Construct();
	
	sdl::LabelWidget* label = new HelloWordLabel();
	label->SetText("Hello World - press 'd' to popup dialog");

	application.GetApplicationWidget().AddWidget(*label, true);
	application.Run();
	
	return 0;
};
