/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __RESOURCE_FILE_H
#define __RESOURCE_FILE_H

#include "platform.h"
#include "types.h"

#include "resources.h"

class ResourceFile
{
public:
	bool Load(const std::string& aFileName, const std::string& aDirectoryName);
	bool Save();
	const std::string& GetFileName() const  { return iFileName; }

protected:
	void Reset() { iResources.Reset(); }
	virtual void OnLoad() { }
	ResourceFile() { }
	Resources iResources;
	
private:
	// resolved filename used to load the resources
	std::string iFileName;
};


#endif // __RESOURCE_FILE_H