/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __PLATFORM_H
#define __PLATFORM_H

#include <string>
#include <vector>

#ifdef WIN32
#define DECLARE_ONCE __declspec(selectany)
#else
#define DECLARE_ONCE __attribute__((weak))
#endif

/*
 * Defines platform specific behavior - implemented for win32 & unix
 */
class Platform
{
public:
	static std::string PathSeperator();
	static bool RunProgram(const std::string& aExeName, const std::string&  aParameter);
	static bool RunProgram(const std::string& aExeName, const std::vector<std::string>&  aArgList);
	static std::string GetPlatformName();
	static bool FileExists(const std::string& aFileName);
	static bool DirectoryExists(const std::string& aDirName);
	static void Shutdown();
};

#endif // __PLATFORM_H
