/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_APPLICATION_H
#define __SDL_APPLICATION_H

#include "sdlcore.h"
#include "sdlapplicationwidget.h"
#include "sdljoy.h"
#include "sdlinfoprint.h"
#include "sdlaudio.h"

namespace sdl
{
	class Application
	{
	public:
		Application(const std::string& aName = "App");
		virtual ~Application();
		
		virtual void Construct();
		virtual void Run();
		
		ApplicationWidget& GetApplicationWidget()	{ return iApplicationWidget; } 
		Audio& GetAudio()							{ return iAudio; }
		std::string GetName() const 				{ return iName; }
		
	protected:
		virtual EventManager* CreateEventManager()	{ return new EventManager; } 
	
	private:
		ApplicationWidget 				iApplicationWidget;
		std::unique_ptr<EventManager>	iEventManager;
		Joystick						iJoystick;
		Audio 							iAudio;
		std::string 					iName;
	};
}

#endif // __SDL_APPLICATION_H