/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_BUTTON_WIDGET_H
#define __SDL_BUTTON_WIDGET_H

#include "sdlcore.h"
#include "sdllabelwidget.h"

namespace sdl
{
	class ButtonWidget : public Widget
	{
	public:
		ButtonWidget(TCommand aCommand = TCommand::ENone);
		~ButtonWidget() {}
		
		void SetText(const std::string& aText)	{ iLabel.SetText(aText); }
		void SetCommand(TCommand aCommand)		{ iCommand = aCommand; }
		virtual bool HasInput() const override	{ return true; }
		virtual int GetMinimumHeight() const override;
		
	protected:
		virtual void Render(IRenderer& aRenderer) override;
		virtual void SizeChanged(const TSize& aOldSize) override { iLabel.SetSize(GetSize()); Widget::SizeChanged(aOldSize); }
		virtual bool HandleCommand(TCommand aCommand) override;
		
		LabelWidget	iLabel; // button text
		TCommand	iCommand;
	};
}

#endif // __SDL_BUTTON_WIDGET_H