/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_I_MENU_LISTENER_H
#define __SDL_I_MENU_LISTENER_H

#include "types.h"
#include "sdlcommands.h"

namespace sdl
{
	class Menu;
	class MenuItem;
	
	class IMenuItemListener
	{
	public:
		virtual void MenuItemHighlighted(const sdl::MenuItem& aMenuItem) = 0;
		virtual void MenuItemCommand(const sdl::MenuItem& aMenuItem, const sdl::TCommand& aCommand) = 0;
		virtual void MenuListChanged(Menu& aMenu) = 0;
	};

	class IMenuChangedListener
	{
	public:
		virtual void MenuChanged(Menu& aMenu) = 0;
	};
}

#endif // __SDL_I_MENU_LISTENER_H