/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_INFO_PRINT_H
#define __SDL_INFO_PRINT_H

#include "sdlcore.h"
#include "sdlcontainer.h"
#include "sdllabelwidget.h"

namespace sdl
{
	class InfoPrint : public Container
	{
	public:
		~InfoPrint();
		
		static void Message(const std::string& aMessage, int aTimeoutInSeconds = -1);
		
	protected:
		InfoPrint();
		void Construct();
		void ApplyProperties();
		
		virtual void CreateCachedTextures(IRenderer& aRenderer) override;
		
		void DoMessage(const std::string& aMessage, int aTimeoutInSeconds);
		void Open(const std::string& aMessage);
		void Close();
		
		void CloseTimer();
		
		LabelWidget	iLabel;
		SDL_TimerID	iTimerId;
	private:
		static InfoPrint* sInfoPrint;
		static void ConstructIfNotAlready();
	};
}

#endif // __SDL_INFO_PRINT_H