/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_LIST_WIDGET_H
#define __SDL_LIST_WIDGET_H

#include "sdlcore.h"
#include "sdlscrollablecontainer.h"
#include "sdllabelwidget.h"

namespace sdl 
{
	class ListWidget : public ScrollableContainer
	{
	public:
		ListWidget() 											{ iScrollbar.SetFormat(ScrollbarWidget::TFormat::ESmall); }
		void AddItem(const std::string& aItem)					{ iListItems.push_back(aItem); }
		void AddItems(const std::vector<std::string>& aItems)	{ iListItems = aItems; }
		TSize CalculateMaxSize();
		
	protected:
		class ListItemWidget : public Widget
		{
		public:
			LabelWidget& GetLabel() { return iLabel; }
		protected:
			virtual int GetMinimumHeight() const override				{ return iLabel.GetMinimumHeight(); }
			virtual bool HasInput() const override 						{ return true; }
			virtual void SizeChanged(const TSize& aOldSize) override	{ iLabel.SetSize(GetSize()); Widget::SizeChanged(aOldSize); }
			virtual void Render(IRenderer& aRenderer) override;
			
			LabelWidget iLabel;
		};

		virtual void PreLayout() override;
	private:
		std::vector<std::string> iListItems;
	};
}

#endif // __SDL_LIST_WIDGET_H