/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_SYSTEM_RENDERER_H
#define __SDL_SYSTEM_RENDERER_H

#include "sdlcore.h"
#include "sdlwidget.h"

namespace sdl 
{
	class SystemRenderer
	{
	public:
		static SystemRenderer Instance;
		
		void Create(const std::string& aWindowTitle);
		void Destroy();
		
		IRenderer* GetRenderer();
		
		void AddTopLevelWidget(Widget& aWidget)		{ iTopLevelWidgets.push_back(&aWidget); }
		void RemoveTopLevelWidget(Widget& aWidget)	{ iTopLevelWidgets.erase(std::find(iTopLevelWidgets.begin(), iTopLevelWidgets.end(), &aWidget)); }
		
		void AddWidget(Widget& aWidget) 			{ iWidgets.push_back(&aWidget); }
		void RemoveWidget(Widget& aWidget)			{ iWidgets.erase(std::find(iWidgets.begin(), iWidgets.end(), &aWidget)); }
		
		void Render();
		void RenderWidgets(IRenderer& aRenderer);
	private:
		std::vector<Widget*> iWidgets;
		std::vector<Widget*> iTopLevelWidgets;
		SystemRenderer() { }
	};
}

#endif // __SDL_SYSTEM_RENDERER_H